﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Windows.Threading;

namespace DataPresenterBug
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private string m_Customizations;

        public MainWindow()
        {
            InitializeComponent();

            AddFields(null, null);

            NextAction(null, SaveCustomizations, "Save Customizations");
        }

        void SaveCustomizations(object sender, EventArgs e)
        {
            m_Customizations = dataPresenter.SaveCustomizations();
            NextAction(SaveCustomizations, ClearFields, "Clear Fields");
        }

        void ClearFields(object sender, EventArgs e)
        {
            dataPresenter.DefaultFieldLayout.Fields.Clear();
            NextAction(ClearFields, AddFields, "Add Fields");
        }

        void AddFields(object sender, EventArgs e)
        {
            List<FakeItem> data = new List<FakeItem>();
            for (int i = 0; i < 10; i++)
            {
                UnboundField field = new UnboundField() { Name = "test" + i };
                field.BindingPath = new PropertyPath("Name");
                dataPresenter.DefaultFieldLayout.Fields.Add(field);

                data.Add(new FakeItem() { Name = "testing" + i });
            }

            dataPresenter.DataSource = data;

            NextAction(AddFields, LoadCustomizations, "Load Customizations");
        }

        void LoadCustomizations(object sender, EventArgs e)
        {
            if (!string.IsNullOrWhiteSpace(m_Customizations))
                dataPresenter.LoadCustomizations(m_Customizations);

            NextAction(LoadCustomizations, ClearFields, "Clear Fields");
        }

        void NextAction(RoutedEventHandler previous, RoutedEventHandler next, string nextActionName)
        {
            if(previous != null)
                btn.Click -= previous;

            btn.Click += next;
            btn.Content = nextActionName;
        }
    }

    public class FakeItem
    {
        public string Name { get; set; }
    }
}
